/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

package jp.co.ntt.lms.installer.lms;

import java.io.File;
import java.util.Properties;
import java.util.logging.Logger;

import jp.co.ntt.lms.installer.core.InstallerAction;
import jp.co.ntt.lms.installer.core.InstallerActionValue;
import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.core.InstallerValues;
import jp.co.ntt.lms.installer.core.util.InstallerCheckUtil;
import jp.co.ntt.lms.installer.core.util.InstallerPropertiesUtil;
import jp.co.ntt.lms.installer.core.util.InstallerUiUtil;
import jp.co.ntt.lms.installer.util.FileUtil;
import jp.co.ntt.lms.installer.util.LoggerUtil;

/**
 * 一括登録の設定について入力するアクション・クラス。
 * @author T.Nishiki
 */
public class LumpInputAction implements InstallerAction {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。
	 */
	static {
		_logger = LoggerUtil.getLogger(LumpInputAction.class);
	}

	/**
	 * アクションをスキップするか判定します。<br>
	 * スキップしないのでfalseを戻します。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return falseを戻します。
	 */
	public boolean isSkipped(InstallerValues values) {
		return false;
	}

	/**
	 * 一括登録の設定について入力・確認を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return LumpInputValueを戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 * @see LumpInputValue
	 */
	public InstallerActionValue action(InstallerValues values)
		throws InstallerException {

		LoggerUtil.methodHead(_logger, "action(InstallerValues)");

		// 今回入力データ
		LumpInputValue inputValue = null;
		try {
			// 既存入力データ（デフォルトデータとして使用）
			LumpInputValue defaultValue = getDefaultValue(values);
			// タイトル表示
			InstallerUiUtil.outputMessageAsTitle(
				values, "LumpInputAction.welcome");

			while (true) {
				// 入力実行
				inputValue = readInputValue(values, defaultValue);
				// 入力確認
				if (confirmInputValue(values, inputValue) == true) {
					// 入力確認が済んだ場合、指定されたディレクトリを
					// 作成対象として登録する。
					File lumpDir = new File(inputValue.getLumpPath());
					values.addMadeDirectory(lumpDir);
					break;
				}
			}
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger, "action(InstallerValues)", inputValue);
		return inputValue;
	}

	/**
	 * 一括登録設定ファイルの書換項目について入力を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param defaultValue デフォルト値。
	 * @return 入力された内容をLumpInputValueとして戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private LumpInputValue readInputValue(
			InstallerValues values, LumpInputValue defaultValue)
			throws InstallerException {
		LoggerUtil.methodHead(_logger,
			"readInputValue(InstallerValues)");

		LumpInputValue inputValue = null;
		try {
			inputValue = new LumpInputValue();
			// =============================================================
			// 一括登録ディレクトリ
			String lumpFilePath = null;
			while (true) {
				lumpFilePath = InstallerUiUtil.askUserInput(values,
						"LumpInputAction.prompt.lumpFilePath",
						defaultValue.getLumpPath());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(lumpFilePath, values,
						"LumpInputAction.error.lumpFilePath.empty")) {
					continue;
				}
				// ファイル
				if (InstallerCheckUtil.isFilePath(lumpFilePath, values,
						"LumpInputAction.error.lumpFilePath.file")) {
					continue;
				}
				break;
			}
			inputValue.setLumpPath(lumpFilePath);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"readInputValue(InstallerValues)", inputValue);
		return inputValue;
	}

	/**
	 * 入力した内容を表示し、ユーザに確認を求めます。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param inputValue 入力された内容
	 * @return 入力された内容にユーザ確認がとれた場合true、
	 *          とれなかった場合falseを戻します。
	 * @throws InstallerException 処理中にエラーが発生した場合。
	 */
	private boolean confirmInputValue(
			InstallerValues values, LumpInputValue inputValue)
			throws InstallerException {

		LoggerUtil.methodHead(_logger,
			"confirmInputValue(InstallerValues, LumpInputValue)");
		boolean confirm = false;
		try {
			InstallerUiUtil.outputConfirmTitle(values,
				"LumpInputAction.confirm.title");
			// =================================================================
			// 入力内容の表示
			// =================================================================
			// 一括登録フォルダパス
			InstallerUiUtil.outputConfirm(values,
				"LumpInputAction.confirm.lumpFilePath",
				inputValue.getLumpPath());
			// =================================================================
			// ユーザ確認
			confirm = InstallerUiUtil.askUserConfirm(
				values, "LumpInputAction.confirm" );
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"confirmInputValue(InstallerValues, LumpInputValue)", confirm);
		return confirm;
	}

	/**
	 * 既存のデータから、入力項目のデフォルト値を取得します。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return デフォルト値をManagerInputValueの形で戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private LumpInputValue getDefaultValue(InstallerValues values)
			throws InstallerException {
		// メソッド開始ログ
		LoggerUtil.methodHead(_logger,
			"getDefaultValue(InstallerValues)");

		LumpInputValue defaultValue = null;
		try {
			defaultValue = new LumpInputValue();
			////////////////////////////////////////////////////////////////////
			// プロパティの取得
			// =================================================================
			// 既存の内容
			File existFile = values.getFileOnSystem(
				defaultValue.getTargetFileKey());
			Properties existProperties
				= FileUtil.loadAsProperties(existFile);
			// =================================================================
			// リソース（原本）の内容
			Properties resourceProperties
				= InstallerPropertiesUtil.load(
						values, defaultValue.getTargetFileKey());
			////////////////////////////////////////////////////////////////////
			// デフォルト値の設定
			// =================================================================
			// 一括登録ディレクトリ
			String lumpPath = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								LumpInputValue.KEY_LUMP_UPLOAD_PATH);
			defaultValue.setLumpPath(lumpPath);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		// メソッド終了ログ
		LoggerUtil.methodTail(_logger,
			"getDefaultValue(InstallerValues)", defaultValue);
		return defaultValue;
	}
}
